.kaniko-image:
  name: gcr.io/kaniko-project/executor:debug
  entrypoint: [ "" ]

.harbor-registry-auth: &harbor-registry-auth
  - mkdir -p /kaniko/.docker
  - echo "{\"auths\":{\"${HARBOR_HOST}\":{\"auth\":\"$(printf "%s:%s" "${HARBOR_USERNAME}" "${HARBOR_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json

build-keycloak-image:
  image: !reference [ .kaniko-image ]
  stage: image-build
  variables:
    KEYCLOAK_VERSION: "23.0.7"
  dependencies: []
  needs: []
  allow_failure: true
  script:
    - *harbor-registry-auth
    - cd deploy/local/docker-compose/keycloak
    - DESTINATION="${HARBOR_HOST}/${HARBOR_PROJECT}/keycloak-jq:${KEYCLOAK_VERSION}"
    - DESTINATION_LATEST="${HARBOR_HOST}/${HARBOR_PROJECT}/keycloak-jq:latest-dev"
    - CREATED=$(date -u +"%Y-%m-%dT%H:%M:%SZ")
    - >-
      /kaniko/executor
      --context "${CI_PROJECT_DIR}/deploy/local/docker-compose/keycloak"
      --dockerfile "${CI_PROJECT_DIR}/deploy/local/docker-compose/keycloak/Dockerfile.keycloak"
      --destination "${DESTINATION}"
      --destination "${DESTINATION_LATEST}"
      --label "org.label-schema.build-date=${CREATED}"
      --label "org.opencontainers.image.created=${CREATED}"
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      when: manual
    - if: $CI_MERGE_REQUEST_IID
      when: manual

build-rabbitmq-image:
  image: !reference [ .kaniko-image ]
  stage: image-build
  variables:
    RABBITMQ_VERSION: "3.9-management"
  dependencies: []
  needs: []
  allow_failure: true
  script:
    - *harbor-registry-auth
    - cd deploy/local/docker-compose/rabbitmq
    - DESTINATION="${HARBOR_HOST}/${HARBOR_PROJECT}/rabbitmq-dev:${RABBITMQ_VERSION}"
    - DESTINATION_LATEST="${HARBOR_HOST}/${HARBOR_PROJECT}/rabbitmq-dev:latest-dev"
    - CREATED=$(date -u +"%Y-%m-%dT%H:%M:%SZ")
    - >-
      /kaniko/executor
      --context "${CI_PROJECT_DIR}/deploy/local/docker-compose/rabbitmq"
      --dockerfile "${CI_PROJECT_DIR}/deploy/local/docker-compose/rabbitmq/Dockerfile.rabbitmq"
      --destination "${DESTINATION}"
      --destination "${DESTINATION_LATEST}"
      --label "org.label-schema.build-date=${CREATED}"
      --label "org.opencontainers.image.created=${CREATED}"
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      when: manual
    - if: $CI_MERGE_REQUEST_IID
      when: manual
